import { NodeType as W, NodeProp as w, Tree as g, IterMode as Vt, TreeFragment as E, Parser as dt, NodeSet as qt } from "./lib19.js";
import { StateField as Z, Facet as S, EditorState as O, StateEffect as U, Prec as zt, RangeSet as Gt, countColumn as Jt, combineConfig as pt, RangeSetBuilder as gt } from "./lib20.js";
import { Decoration as m, Direction as it, EditorView as v, ViewPlugin as _, logException as Kt, gutter as Qt, WidgetType as mt, GutterMarker as Xt } from "./lib21.js";
import { tags as f, styleTags as Yt, tagHighlighter as Zt, highlightTree as _t } from "./lib22.js";
import { StyleModule as st } from "./lib23.js";
var V;
const P = /* @__PURE__ */ new w();
function kt(n) {
  return S.define({
    combine: n ? (t) => t.concat(n) : void 0
  });
}
const te = /* @__PURE__ */ new w();
class k {
  /**
  Construct a language object. If you need to invoke this
  directly, first define a data facet with
  [`defineLanguageFacet`](https://codemirror.net/6/docs/ref/#language.defineLanguageFacet), and then
  configure your parser to [attach](https://codemirror.net/6/docs/ref/#language.languageDataProp) it
  to the language's outer syntax node.
  */
  constructor(t, e, r = [], i = "") {
    this.data = t, this.name = i, O.prototype.hasOwnProperty("tree") || Object.defineProperty(O.prototype, "tree", { get() {
      return b(this);
    } }), this.parser = e, this.extension = [
      x.of(this),
      O.languageData.of((s, o, a) => {
        let l = ot(s, o, a), h = l.type.prop(P);
        if (!h)
          return [];
        let u = s.facet(h), c = l.type.prop(te);
        if (c) {
          let p = l.resolve(o - l.from, a);
          for (let d of c)
            if (d.test(p, s)) {
              let y = s.facet(d.facet);
              return d.type == "replace" ? y : y.concat(u);
            }
        }
        return u;
      })
    ].concat(r);
  }
  /**
  Query whether this language is active at the given position.
  */
  isActiveAt(t, e, r = -1) {
    return ot(t, e, r).type.prop(P) == this.data;
  }
  /**
  Find the document regions that were parsed using this language.
  The returned regions will _include_ any nested languages rooted
  in this language, when those exist.
  */
  findRegions(t) {
    let e = t.facet(x);
    if ((e == null ? void 0 : e.data) == this.data)
      return [{ from: 0, to: t.doc.length }];
    if (!e || !e.allowsNesting)
      return [];
    let r = [], i = (s, o) => {
      if (s.prop(P) == this.data) {
        r.push({ from: o, to: o + s.length });
        return;
      }
      let a = s.prop(w.mounted);
      if (a) {
        if (a.tree.prop(P) == this.data) {
          if (a.overlay)
            for (let l of a.overlay)
              r.push({ from: l.from + o, to: l.to + o });
          else
            r.push({ from: o, to: o + s.length });
          return;
        } else if (a.overlay) {
          let l = r.length;
          if (i(a.tree, a.overlay[0].from + o), r.length > l)
            return;
        }
      }
      for (let l = 0; l < s.children.length; l++) {
        let h = s.children[l];
        h instanceof g && i(h, s.positions[l] + o);
      }
    };
    return i(b(t), 0), r;
  }
  /**
  Indicates whether this language allows nested languages. The
  default implementation returns true.
  */
  get allowsNesting() {
    return !0;
  }
}
k.setState = /* @__PURE__ */ U.define();
function ot(n, t, e) {
  let r = n.facet(x), i = b(n).topNode;
  if (!r || r.allowsNesting)
    for (let s = i; s; s = s.enter(t, e, Vt.ExcludeBuffers))
      s.type.isTop && (i = s);
  return i;
}
class K extends k {
  constructor(t, e, r) {
    super(t, e, [], r), this.parser = e;
  }
  /**
  Define a language from a parser.
  */
  static define(t) {
    let e = kt(t.languageData);
    return new K(e, t.parser.configure({
      props: [P.add((r) => r.isTop ? e : void 0)]
    }), t.name);
  }
  /**
  Create a new instance of this language with a reconfigured
  version of its parser and optionally a new name.
  */
  configure(t, e) {
    return new K(this.data, this.parser.configure(t), e || this.name);
  }
  get allowsNesting() {
    return this.parser.hasWrappers();
  }
}
function b(n) {
  let t = n.field(k.state, !1);
  return t ? t.tree : g.empty;
}
class ee {
  /**
  Create an input object for the given document.
  */
  constructor(t) {
    this.doc = t, this.cursorPos = 0, this.string = "", this.cursor = t.iter();
  }
  get length() {
    return this.doc.length;
  }
  syncTo(t) {
    return this.string = this.cursor.next(t - this.cursorPos).value, this.cursorPos = t + this.string.length, this.cursorPos - this.string.length;
  }
  chunk(t) {
    return this.syncTo(t), this.string;
  }
  get lineChunks() {
    return !0;
  }
  read(t, e) {
    let r = this.cursorPos - this.string.length;
    return t < r || e >= this.cursorPos ? this.doc.sliceString(t, e) : this.string.slice(t - r, e - r);
  }
}
let D = null;
class A {
  constructor(t, e, r = [], i, s, o, a, l) {
    this.parser = t, this.state = e, this.fragments = r, this.tree = i, this.treeLen = s, this.viewport = o, this.skipped = a, this.scheduleOn = l, this.parse = null, this.tempSkipped = [];
  }
  /**
  @internal
  */
  static create(t, e, r) {
    return new A(t, e, [], g.empty, 0, r, [], null);
  }
  startParse() {
    return this.parser.startParse(new ee(this.state.doc), this.fragments);
  }
  /**
  @internal
  */
  work(t, e) {
    return e != null && e >= this.state.doc.length && (e = void 0), this.tree != g.empty && this.isDone(e ?? this.state.doc.length) ? (this.takeTree(), !0) : this.withContext(() => {
      var r;
      if (typeof t == "number") {
        let i = Date.now() + t;
        t = () => Date.now() > i;
      }
      for (this.parse || (this.parse = this.startParse()), e != null && (this.parse.stoppedAt == null || this.parse.stoppedAt > e) && e < this.state.doc.length && this.parse.stopAt(e); ; ) {
        let i = this.parse.advance();
        if (i)
          if (this.fragments = this.withoutTempSkipped(E.addTree(i, this.fragments, this.parse.stoppedAt != null)), this.treeLen = (r = this.parse.stoppedAt) !== null && r !== void 0 ? r : this.state.doc.length, this.tree = i, this.parse = null, this.treeLen < (e ?? this.state.doc.length))
            this.parse = this.startParse();
          else
            return !0;
        if (t())
          return !1;
      }
    });
  }
  /**
  @internal
  */
  takeTree() {
    let t, e;
    this.parse && (t = this.parse.parsedPos) >= this.treeLen && ((this.parse.stoppedAt == null || this.parse.stoppedAt > t) && this.parse.stopAt(t), this.withContext(() => {
      for (; !(e = this.parse.advance()); )
        ;
    }), this.treeLen = t, this.tree = e, this.fragments = this.withoutTempSkipped(E.addTree(this.tree, this.fragments, !0)), this.parse = null);
  }
  withContext(t) {
    let e = D;
    D = this;
    try {
      return t();
    } finally {
      D = e;
    }
  }
  withoutTempSkipped(t) {
    for (let e; e = this.tempSkipped.pop(); )
      t = lt(t, e.from, e.to);
    return t;
  }
  /**
  @internal
  */
  changes(t, e) {
    let { fragments: r, tree: i, treeLen: s, viewport: o, skipped: a } = this;
    if (this.takeTree(), !t.empty) {
      let l = [];
      if (t.iterChangedRanges((h, u, c, p) => l.push({ fromA: h, toA: u, fromB: c, toB: p })), r = E.applyChanges(r, l), i = g.empty, s = 0, o = { from: t.mapPos(o.from, -1), to: t.mapPos(o.to, 1) }, this.skipped.length) {
        a = [];
        for (let h of this.skipped) {
          let u = t.mapPos(h.from, 1), c = t.mapPos(h.to, -1);
          u < c && a.push({ from: u, to: c });
        }
      }
    }
    return new A(this.parser, e, r, i, s, o, a, this.scheduleOn);
  }
  /**
  @internal
  */
  updateViewport(t) {
    if (this.viewport.from == t.from && this.viewport.to == t.to)
      return !1;
    this.viewport = t;
    let e = this.skipped.length;
    for (let r = 0; r < this.skipped.length; r++) {
      let { from: i, to: s } = this.skipped[r];
      i < t.to && s > t.from && (this.fragments = lt(this.fragments, i, s), this.skipped.splice(r--, 1));
    }
    return this.skipped.length >= e ? !1 : (this.reset(), !0);
  }
  /**
  @internal
  */
  reset() {
    this.parse && (this.takeTree(), this.parse = null);
  }
  /**
  Notify the parse scheduler that the given region was skipped
  because it wasn't in view, and the parse should be restarted
  when it comes into view.
  */
  skipUntilInView(t, e) {
    this.skipped.push({ from: t, to: e });
  }
  /**
  Returns a parser intended to be used as placeholder when
  asynchronously loading a nested parser. It'll skip its input and
  mark it as not-really-parsed, so that the next update will parse
  it again.
  
  When `until` is given, a reparse will be scheduled when that
  promise resolves.
  */
  static getSkippingParser(t) {
    return new class extends dt {
      createParse(e, r, i) {
        let s = i[0].from, o = i[i.length - 1].to;
        return {
          parsedPos: s,
          advance() {
            let l = D;
            if (l) {
              for (let h of i)
                l.tempSkipped.push(h);
              t && (l.scheduleOn = l.scheduleOn ? Promise.all([l.scheduleOn, t]) : t);
            }
            return this.parsedPos = o, new g(W.none, [], [], o - s);
          },
          stoppedAt: null,
          stopAt() {
          }
        };
      }
    }();
  }
  /**
  @internal
  */
  isDone(t) {
    t = Math.min(t, this.state.doc.length);
    let e = this.fragments;
    return this.treeLen >= t && e.length && e[0].from == 0 && e[0].to >= t;
  }
  /**
  Get the context for the current parse, or `null` if no editor
  parse is in progress.
  */
  static get() {
    return D;
  }
}
function lt(n, t, e) {
  return E.applyChanges(n, [{ fromA: t, toA: e, fromB: t, toB: e }]);
}
class I {
  constructor(t) {
    this.context = t, this.tree = t.tree;
  }
  apply(t) {
    if (!t.docChanged && this.tree == this.context.tree)
      return this;
    let e = this.context.changes(t.changes, t.state), r = this.context.treeLen == t.startState.doc.length ? void 0 : Math.max(t.changes.mapPos(this.context.treeLen), e.viewport.to);
    return e.work(20, r) || e.takeTree(), new I(e);
  }
  static init(t) {
    let e = Math.min(3e3, t.doc.length), r = A.create(t.facet(x).parser, t, { from: 0, to: e });
    return r.work(20, e) || r.takeTree(), new I(r);
  }
}
k.state = /* @__PURE__ */ Z.define({
  create: I.init,
  update(n, t) {
    for (let e of t.effects)
      if (e.is(k.setState))
        return e.value;
    return t.startState.facet(x) != t.state.facet(x) ? I.init(t.state) : n.apply(t);
  }
});
let bt = (n) => {
  let t = setTimeout(
    () => n(),
    500
    /* Work.MaxPause */
  );
  return () => clearTimeout(t);
};
typeof requestIdleCallback < "u" && (bt = (n) => {
  let t = -1, e = setTimeout(
    () => {
      t = requestIdleCallback(n, {
        timeout: 400
        /* Work.MinPause */
      });
    },
    100
    /* Work.MinPause */
  );
  return () => t < 0 ? clearTimeout(e) : cancelIdleCallback(t);
});
const q = typeof navigator < "u" && (!((V = navigator.scheduling) === null || V === void 0) && V.isInputPending) ? () => navigator.scheduling.isInputPending() : null, ne = /* @__PURE__ */ _.fromClass(class {
  constructor(t) {
    this.view = t, this.working = null, this.workScheduled = 0, this.chunkEnd = -1, this.chunkBudget = -1, this.work = this.work.bind(this), this.scheduleWork();
  }
  update(t) {
    let e = this.view.state.field(k.state).context;
    (e.updateViewport(t.view.viewport) || this.view.viewport.to > e.treeLen) && this.scheduleWork(), (t.docChanged || t.selectionSet) && (this.view.hasFocus && (this.chunkBudget += 50), this.scheduleWork()), this.checkAsyncSchedule(e);
  }
  scheduleWork() {
    if (this.working)
      return;
    let { state: t } = this.view, e = t.field(k.state);
    (e.tree != e.context.tree || !e.context.isDone(t.doc.length)) && (this.working = bt(this.work));
  }
  work(t) {
    this.working = null;
    let e = Date.now();
    if (this.chunkEnd < e && (this.chunkEnd < 0 || this.view.hasFocus) && (this.chunkEnd = e + 3e4, this.chunkBudget = 3e3), this.chunkBudget <= 0)
      return;
    let { state: r, viewport: { to: i } } = this.view, s = r.field(k.state);
    if (s.tree == s.context.tree && s.context.isDone(
      i + 1e5
      /* Work.MaxParseAhead */
    ))
      return;
    let o = Date.now() + Math.min(this.chunkBudget, 100, t && !q ? Math.max(25, t.timeRemaining() - 5) : 1e9), a = s.context.treeLen < i && r.doc.length > i + 1e3, l = s.context.work(() => q && q() || Date.now() > o, i + (a ? 0 : 1e5));
    this.chunkBudget -= Date.now() - e, (l || this.chunkBudget <= 0) && (s.context.takeTree(), this.view.dispatch({ effects: k.setState.of(new I(s.context)) })), this.chunkBudget > 0 && !(l && !a) && this.scheduleWork(), this.checkAsyncSchedule(s.context);
  }
  checkAsyncSchedule(t) {
    t.scheduleOn && (this.workScheduled++, t.scheduleOn.then(() => this.scheduleWork()).catch((e) => Kt(this.view.state, e)).then(() => this.workScheduled--), t.scheduleOn = null);
  }
  destroy() {
    this.working && this.working();
  }
  isWorking() {
    return !!(this.working || this.workScheduled > 0);
  }
}, {
  eventHandlers: { focus() {
    this.scheduleWork();
  } }
}), x = /* @__PURE__ */ S.define({
  combine(n) {
    return n.length ? n[0] : null;
  },
  enables: (n) => [
    k.state,
    ne,
    v.contentAttributes.compute([n], (t) => {
      let e = t.facet(n);
      return e && e.name ? { "data-language": e.name } : {};
    })
  ]
});
class Xe {
  /**
  Create a language support object.
  */
  constructor(t, e = []) {
    this.language = t, this.support = e, this.extension = [t, e];
  }
}
class wt {
  constructor(t, e, r, i, s, o = void 0) {
    this.name = t, this.alias = e, this.extensions = r, this.filename = i, this.loadFunc = s, this.support = o, this.loading = null;
  }
  /**
  Start loading the the language. Will return a promise that
  resolves to a [`LanguageSupport`](https://codemirror.net/6/docs/ref/#language.LanguageSupport)
  object when the language successfully loads.
  */
  load() {
    return this.loading || (this.loading = this.loadFunc().then((t) => this.support = t, (t) => {
      throw this.loading = null, t;
    }));
  }
  /**
  Create a language description.
  */
  static of(t) {
    let { load: e, support: r } = t;
    if (!e) {
      if (!r)
        throw new RangeError("Must pass either 'load' or 'support' to LanguageDescription.of");
      e = () => Promise.resolve(r);
    }
    return new wt(t.name, (t.alias || []).concat(t.name).map((i) => i.toLowerCase()), t.extensions || [], t.filename, e, r);
  }
  /**
  Look for a language in the given array of descriptions that
  matches the filename. Will first match
  [`filename`](https://codemirror.net/6/docs/ref/#language.LanguageDescription.filename) patterns,
  and then [extensions](https://codemirror.net/6/docs/ref/#language.LanguageDescription.extensions),
  and return the first language that matches.
  */
  static matchFilename(t, e) {
    for (let i of t)
      if (i.filename && i.filename.test(e))
        return i;
    let r = /\.([^.]+)$/.exec(e);
    if (r) {
      for (let i of t)
        if (i.extensions.indexOf(r[1]) > -1)
          return i;
    }
    return null;
  }
  /**
  Look for a language whose name or alias matches the the given
  name (case-insensitively). If `fuzzy` is true, and no direct
  matchs is found, this'll also search for a language whose name
  or alias occurs in the string (for names shorter than three
  characters, only when surrounded by non-word characters).
  */
  static matchLanguageName(t, e, r = !0) {
    e = e.toLowerCase();
    for (let i of t)
      if (i.alias.some((s) => s == e))
        return i;
    if (r)
      for (let i of t)
        for (let s of i.alias) {
          let o = e.indexOf(s);
          if (o > -1 && (s.length > 2 || !/\w/.test(e[o - 1]) && !/\w/.test(e[o + s.length])))
            return i;
        }
    return null;
  }
}
const yt = /* @__PURE__ */ S.define(), vt = /* @__PURE__ */ S.define({
  combine: (n) => {
    if (!n.length)
      return "  ";
    let t = n[0];
    if (!t || /\S/.test(t) || Array.from(t).some((e) => e != t[0]))
      throw new Error("Invalid indent unit: " + JSON.stringify(n[0]));
    return t;
  }
});
function L(n) {
  let t = n.facet(vt);
  return t.charCodeAt(0) == 9 ? n.tabSize * t.length : t.length;
}
function re(n, t) {
  let e = "", r = n.tabSize, i = n.facet(vt)[0];
  if (i == "	") {
    for (; t >= r; )
      e += "	", t -= r;
    i = " ";
  }
  for (let s = 0; s < t; s++)
    e += i;
  return e;
}
function ie(n, t) {
  n instanceof O && (n = new St(n));
  for (let r of n.state.facet(yt)) {
    let i = r(n, t);
    if (i !== void 0)
      return i;
  }
  let e = b(n.state);
  return e.length >= t ? oe(n, e, t) : null;
}
class St {
  /**
  Create an indent context.
  */
  constructor(t, e = {}) {
    this.state = t, this.options = e, this.unit = L(t);
  }
  /**
  Get a description of the line at the given position, taking
  [simulated line
  breaks](https://codemirror.net/6/docs/ref/#language.IndentContext.constructor^options.simulateBreak)
  into account. If there is such a break at `pos`, the `bias`
  argument determines whether the part of the line line before or
  after the break is used.
  */
  lineAt(t, e = 1) {
    let r = this.state.doc.lineAt(t), { simulateBreak: i, simulateDoubleBreak: s } = this.options;
    return i != null && i >= r.from && i <= r.to ? s && i == t ? { text: "", from: t } : (e < 0 ? i < t : i <= t) ? { text: r.text.slice(i - r.from), from: i } : { text: r.text.slice(0, i - r.from), from: r.from } : r;
  }
  /**
  Get the text directly after `pos`, either the entire line
  or the next 100 characters, whichever is shorter.
  */
  textAfterPos(t, e = 1) {
    if (this.options.simulateDoubleBreak && t == this.options.simulateBreak)
      return "";
    let { text: r, from: i } = this.lineAt(t, e);
    return r.slice(t - i, Math.min(r.length, t + 100 - i));
  }
  /**
  Find the column for the given position.
  */
  column(t, e = 1) {
    let { text: r, from: i } = this.lineAt(t, e), s = this.countColumn(r, t - i), o = this.options.overrideIndentation ? this.options.overrideIndentation(i) : -1;
    return o > -1 && (s += o - this.countColumn(r, r.search(/\S|$/))), s;
  }
  /**
  Find the column position (taking tabs into account) of the given
  position in the given string.
  */
  countColumn(t, e = t.length) {
    return Jt(t, this.state.tabSize, e);
  }
  /**
  Find the indentation column of the line at the given point.
  */
  lineIndent(t, e = 1) {
    let { text: r, from: i } = this.lineAt(t, e), s = this.options.overrideIndentation;
    if (s) {
      let o = s(i);
      if (o > -1)
        return o;
    }
    return this.countColumn(r, r.search(/\S|$/));
  }
  /**
  Returns the [simulated line
  break](https://codemirror.net/6/docs/ref/#language.IndentContext.constructor^options.simulateBreak)
  for this context, if any.
  */
  get simulatedBreak() {
    return this.options.simulateBreak || null;
  }
}
const se = /* @__PURE__ */ new w();
function oe(n, t, e) {
  let r = t.resolveStack(e), i = r.node.enterUnfinishedNodesBefore(e);
  if (i != r.node) {
    let s = [];
    for (let o = i; o != r.node; o = o.parent)
      s.push(o);
    for (let o = s.length - 1; o >= 0; o--)
      r = { node: s[o], next: r };
  }
  return xt(r, n, e);
}
function xt(n, t, e) {
  for (let r = n; r; r = r.next) {
    let i = ae(r.node);
    if (i)
      return i(tt.create(t, e, r));
  }
  return 0;
}
function le(n) {
  return n.pos == n.options.simulateBreak && n.options.simulateDoubleBreak;
}
function ae(n) {
  let t = n.type.prop(se);
  if (t)
    return t;
  let e = n.firstChild, r;
  if (e && (r = e.type.prop(w.closedBy))) {
    let i = n.lastChild, s = i && r.indexOf(i.name) > -1;
    return (o) => Pt(o, !0, 1, void 0, s && !le(o) ? i.from : void 0);
  }
  return n.parent == null ? he : null;
}
function he() {
  return 0;
}
class tt extends St {
  constructor(t, e, r) {
    super(t.state, t.options), this.base = t, this.pos = e, this.context = r;
  }
  /**
  The syntax tree node to which the indentation strategy
  applies.
  */
  get node() {
    return this.context.node;
  }
  /**
  @internal
  */
  static create(t, e, r) {
    return new tt(t, e, r);
  }
  /**
  Get the text directly after `this.pos`, either the entire line
  or the next 100 characters, whichever is shorter.
  */
  get textAfter() {
    return this.textAfterPos(this.pos);
  }
  /**
  Get the indentation at the reference line for `this.node`, which
  is the line on which it starts, unless there is a node that is
  _not_ a parent of this node covering the start of that line. If
  so, the line at the start of that node is tried, again skipping
  on if it is covered by another such node.
  */
  get baseIndent() {
    return this.baseIndentFor(this.node);
  }
  /**
  Get the indentation for the reference line of the given node
  (see [`baseIndent`](https://codemirror.net/6/docs/ref/#language.TreeIndentContext.baseIndent)).
  */
  baseIndentFor(t) {
    let e = this.state.doc.lineAt(t.from);
    for (; ; ) {
      let r = t.resolve(e.from);
      for (; r.parent && r.parent.from == r.from; )
        r = r.parent;
      if (ue(r, t))
        break;
      e = this.state.doc.lineAt(r.from);
    }
    return this.lineIndent(e.from);
  }
  /**
  Continue looking for indentations in the node's parent nodes,
  and return the result of that.
  */
  continue() {
    return xt(this.context.next, this.base, this.pos);
  }
}
function ue(n, t) {
  for (let e = t; e; e = e.parent)
    if (n == e)
      return !0;
  return !1;
}
function fe(n) {
  let t = n.node, e = t.childAfter(t.from), r = t.lastChild;
  if (!e)
    return null;
  let i = n.options.simulateBreak, s = n.state.doc.lineAt(e.from), o = i == null || i <= s.from ? s.to : Math.min(s.to, i);
  for (let a = e.to; ; ) {
    let l = t.childAfter(a);
    if (!l || l == r)
      return null;
    if (!l.type.isSkipped)
      return l.from < o ? e : null;
    a = l.to;
  }
}
function Ye({ closing: n, align: t = !0, units: e = 1 }) {
  return (r) => Pt(r, t, e, n);
}
function Pt(n, t, e, r, i) {
  let s = n.textAfter, o = s.match(/^\s*/)[0].length, a = r && s.slice(o, o + r.length) == r || i == n.pos + o, l = t ? fe(n) : null;
  return l ? a ? n.column(l.from) : n.column(l.to) : n.baseIndent + (a ? 0 : n.unit * e);
}
const Ze = (n) => n.baseIndent;
function _e({ except: n, units: t = 1 } = {}) {
  return (e) => {
    let r = n && n.test(e.textAfter);
    return e.baseIndent + (r ? 0 : t * e.unit);
  };
}
const ce = 200;
function tn() {
  return O.transactionFilter.of((n) => {
    if (!n.docChanged || !n.isUserEvent("input.type") && !n.isUserEvent("input.complete"))
      return n;
    let t = n.startState.languageDataAt("indentOnInput", n.startState.selection.main.head);
    if (!t.length)
      return n;
    let e = n.newDoc, { head: r } = n.newSelection.main, i = e.lineAt(r);
    if (r > i.from + ce)
      return n;
    let s = e.sliceString(i.from, r);
    if (!t.some((h) => h.test(s)))
      return n;
    let { state: o } = n, a = -1, l = [];
    for (let { head: h } of o.selection.ranges) {
      let u = o.doc.lineAt(h);
      if (u.from == a)
        continue;
      a = u.from;
      let c = ie(o, u.from);
      if (c == null)
        continue;
      let p = /^\s*/.exec(u.text)[0], d = re(o, c);
      p != d && l.push({ from: u.from, to: u.from + p.length, insert: d });
    }
    return l.length ? [n, { changes: l, sequential: !0 }] : n;
  });
}
const de = /* @__PURE__ */ S.define(), pe = /* @__PURE__ */ new w();
function en(n) {
  let t = n.firstChild, e = n.lastChild;
  return t && t.to < e.from ? { from: t.to, to: e.type.isError ? n.to : e.from } : null;
}
function ge(n, t, e) {
  let r = b(n);
  if (r.length < e)
    return null;
  let i = r.resolveStack(e, 1), s = null;
  for (let o = i; o; o = o.next) {
    let a = o.node;
    if (a.to <= e || a.from > e)
      continue;
    if (s && a.from < t)
      break;
    let l = a.type.prop(pe);
    if (l && (a.to < r.length - 50 || r.length == n.doc.length || !me(a))) {
      let h = l(a, n);
      h && h.from <= e && h.from >= t && h.to > e && (s = h);
    }
  }
  return s;
}
function me(n) {
  let t = n.lastChild;
  return t && t.to == n.to && t.type.isError;
}
function F(n, t, e) {
  for (let r of n.facet(de)) {
    let i = r(n, t, e);
    if (i)
      return i;
  }
  return ge(n, t, e);
}
function Tt(n, t) {
  let e = t.mapPos(n.from, 1), r = t.mapPos(n.to, -1);
  return e >= r ? void 0 : { from: e, to: r };
}
const H = /* @__PURE__ */ U.define({ map: Tt }), M = /* @__PURE__ */ U.define({ map: Tt });
function Ct(n) {
  let t = [];
  for (let { head: e } of n.state.selection.ranges)
    t.some((r) => r.from <= e && r.to >= e) || t.push(n.lineBlockAt(e));
  return t;
}
const T = /* @__PURE__ */ Z.define({
  create() {
    return m.none;
  },
  update(n, t) {
    n = n.map(t.changes);
    for (let e of t.effects)
      if (e.is(H) && !ke(n, e.value.from, e.value.to)) {
        let { preparePlaceholder: r } = t.state.facet(et), i = r ? m.replace({ widget: new xe(r(t.state, e.value)) }) : at;
        n = n.update({ add: [i.range(e.value.from, e.value.to)] });
      } else
        e.is(M) && (n = n.update({
          filter: (r, i) => e.value.from != r || e.value.to != i,
          filterFrom: e.value.from,
          filterTo: e.value.to
        }));
    if (t.selection) {
      let e = !1, { head: r } = t.selection.main;
      n.between(r, r, (i, s) => {
        i < r && s > r && (e = !0);
      }), e && (n = n.update({
        filterFrom: r,
        filterTo: r,
        filter: (i, s) => s <= r || i >= r
      }));
    }
    return n;
  },
  provide: (n) => v.decorations.from(n),
  toJSON(n, t) {
    let e = [];
    return n.between(0, t.doc.length, (r, i) => {
      e.push(r, i);
    }), e;
  },
  fromJSON(n) {
    if (!Array.isArray(n) || n.length % 2)
      throw new RangeError("Invalid JSON for fold state");
    let t = [];
    for (let e = 0; e < n.length; ) {
      let r = n[e++], i = n[e++];
      if (typeof r != "number" || typeof i != "number")
        throw new RangeError("Invalid JSON for fold state");
      t.push(at.range(r, i));
    }
    return m.set(t, !0);
  }
});
function R(n, t, e) {
  var r;
  let i = null;
  return (r = n.field(T, !1)) === null || r === void 0 || r.between(t, e, (s, o) => {
    (!i || i.from > s) && (i = { from: s, to: o });
  }), i;
}
function ke(n, t, e) {
  let r = !1;
  return n.between(t, t, (i, s) => {
    i == t && s == e && (r = !0);
  }), r;
}
function At(n, t) {
  return n.field(T, !1) ? t : t.concat(U.appendConfig.of(Dt()));
}
const be = (n) => {
  for (let t of Ct(n)) {
    let e = F(n.state, t.from, t.to);
    if (e)
      return n.dispatch({ effects: At(n.state, [H.of(e), It(n, e)]) }), !0;
  }
  return !1;
}, we = (n) => {
  if (!n.state.field(T, !1))
    return !1;
  let t = [];
  for (let e of Ct(n)) {
    let r = R(n.state, e.from, e.to);
    r && t.push(M.of(r), It(n, r, !1));
  }
  return t.length && n.dispatch({ effects: t }), t.length > 0;
};
function It(n, t, e = !0) {
  let r = n.state.doc.lineAt(t.from).number, i = n.state.doc.lineAt(t.to).number;
  return v.announce.of(`${n.state.phrase(e ? "Folded lines" : "Unfolded lines")} ${r} ${n.state.phrase("to")} ${i}.`);
}
const ye = (n) => {
  let { state: t } = n, e = [];
  for (let r = 0; r < t.doc.length; ) {
    let i = n.lineBlockAt(r), s = F(t, i.from, i.to);
    s && e.push(H.of(s)), r = (s ? n.lineBlockAt(s.to) : i).to + 1;
  }
  return e.length && n.dispatch({ effects: At(n.state, e) }), !!e.length;
}, ve = (n) => {
  let t = n.state.field(T, !1);
  if (!t || !t.size)
    return !1;
  let e = [];
  return t.between(0, n.state.doc.length, (r, i) => {
    e.push(M.of({ from: r, to: i }));
  }), n.dispatch({ effects: e }), !0;
}, nn = [
  { key: "Ctrl-Shift-[", mac: "Cmd-Alt-[", run: be },
  { key: "Ctrl-Shift-]", mac: "Cmd-Alt-]", run: we },
  { key: "Ctrl-Alt-[", run: ye },
  { key: "Ctrl-Alt-]", run: ve }
], Se = {
  placeholderDOM: null,
  preparePlaceholder: null,
  placeholderText: "…"
}, et = /* @__PURE__ */ S.define({
  combine(n) {
    return pt(n, Se);
  }
});
function Dt(n) {
  let t = [T, Te];
  return n && t.push(et.of(n)), t;
}
function Ot(n, t) {
  let { state: e } = n, r = e.facet(et), i = (o) => {
    let a = n.lineBlockAt(n.posAtDOM(o.target)), l = R(n.state, a.from, a.to);
    l && n.dispatch({ effects: M.of(l) }), o.preventDefault();
  };
  if (r.placeholderDOM)
    return r.placeholderDOM(n, i, t);
  let s = document.createElement("span");
  return s.textContent = r.placeholderText, s.setAttribute("aria-label", e.phrase("folded code")), s.title = e.phrase("unfold"), s.className = "cm-foldPlaceholder", s.onclick = i, s;
}
const at = /* @__PURE__ */ m.replace({ widget: /* @__PURE__ */ new class extends mt {
  toDOM(n) {
    return Ot(n, null);
  }
}() });
class xe extends mt {
  constructor(t) {
    super(), this.value = t;
  }
  eq(t) {
    return this.value == t.value;
  }
  toDOM(t) {
    return Ot(t, this.value);
  }
}
const Pe = {
  openText: "⌄",
  closedText: "›",
  markerDOM: null,
  domEventHandlers: {},
  foldingChanged: () => !1
};
class z extends Xt {
  constructor(t, e) {
    super(), this.config = t, this.open = e;
  }
  eq(t) {
    return this.config == t.config && this.open == t.open;
  }
  toDOM(t) {
    if (this.config.markerDOM)
      return this.config.markerDOM(this.open);
    let e = document.createElement("span");
    return e.textContent = this.open ? this.config.openText : this.config.closedText, e.title = t.state.phrase(this.open ? "Fold line" : "Unfold line"), e;
  }
}
function rn(n = {}) {
  let t = Object.assign(Object.assign({}, Pe), n), e = new z(t, !0), r = new z(t, !1), i = _.fromClass(class {
    constructor(o) {
      this.from = o.viewport.from, this.markers = this.buildMarkers(o);
    }
    update(o) {
      (o.docChanged || o.viewportChanged || o.startState.facet(x) != o.state.facet(x) || o.startState.field(T, !1) != o.state.field(T, !1) || b(o.startState) != b(o.state) || t.foldingChanged(o)) && (this.markers = this.buildMarkers(o.view));
    }
    buildMarkers(o) {
      let a = new gt();
      for (let l of o.viewportLineBlocks) {
        let h = R(o.state, l.from, l.to) ? r : F(o.state, l.from, l.to) ? e : null;
        h && a.add(l.from, l.from, h);
      }
      return a.finish();
    }
  }), { domEventHandlers: s } = t;
  return [
    i,
    Qt({
      class: "cm-foldGutter",
      markers(o) {
        var a;
        return ((a = o.plugin(i)) === null || a === void 0 ? void 0 : a.markers) || Gt.empty;
      },
      initialSpacer() {
        return new z(t, !1);
      },
      domEventHandlers: Object.assign(Object.assign({}, s), { click: (o, a, l) => {
        if (s.click && s.click(o, a, l))
          return !0;
        let h = R(o.state, a.from, a.to);
        if (h)
          return o.dispatch({ effects: M.of(h) }), !0;
        let u = F(o.state, a.from, a.to);
        return u ? (o.dispatch({ effects: H.of(u) }), !0) : !1;
      } })
    }),
    Dt()
  ];
}
const Te = /* @__PURE__ */ v.baseTheme({
  ".cm-foldPlaceholder": {
    backgroundColor: "#eee",
    border: "1px solid #ddd",
    color: "#888",
    borderRadius: ".2em",
    margin: "0 1px",
    padding: "0 1px",
    cursor: "pointer"
  },
  ".cm-foldGutter span": {
    padding: "0 1px",
    cursor: "pointer"
  }
});
class j {
  constructor(t, e) {
    this.specs = t;
    let r;
    function i(a) {
      let l = st.newName();
      return (r || (r = /* @__PURE__ */ Object.create(null)))["." + l] = a, l;
    }
    const s = typeof e.all == "string" ? e.all : e.all ? i(e.all) : void 0, o = e.scope;
    this.scope = o instanceof k ? (a) => a.prop(P) == o.data : o ? (a) => a == o : void 0, this.style = Zt(t.map((a) => ({
      tag: a.tag,
      class: a.class || i(Object.assign({}, a, { tag: null }))
    })), {
      all: s
    }).style, this.module = r ? new st(r) : null, this.themeType = e.themeType;
  }
  /**
  Create a highlighter style that associates the given styles to
  the given tags. The specs must be objects that hold a style tag
  or array of tags in their `tag` property, and either a single
  `class` property providing a static CSS class (for highlighter
  that rely on external styling), or a
  [`style-mod`](https://github.com/marijnh/style-mod#documentation)-style
  set of CSS properties (which define the styling for those tags).
  
  The CSS rules created for a highlighter will be emitted in the
  order of the spec's properties. That means that for elements that
  have multiple tags associated with them, styles defined further
  down in the list will have a higher CSS precedence than styles
  defined earlier.
  */
  static define(t, e) {
    return new j(t, e || {});
  }
}
const Q = /* @__PURE__ */ S.define(), Nt = /* @__PURE__ */ S.define({
  combine(n) {
    return n.length ? [n[0]] : null;
  }
});
function G(n) {
  let t = n.facet(Q);
  return t.length ? t : n.facet(Nt);
}
function sn(n, t) {
  let e = [Ae], r;
  return n instanceof j && (n.module && e.push(v.styleModule.of(n.module)), r = n.themeType), t != null && t.fallback ? e.push(Nt.of(n)) : r ? e.push(Q.computeN([v.darkTheme], (i) => i.facet(v.darkTheme) == (r == "dark") ? [n] : [])) : e.push(Q.of(n)), e;
}
class Ce {
  constructor(t) {
    this.markCache = /* @__PURE__ */ Object.create(null), this.tree = b(t.state), this.decorations = this.buildDeco(t, G(t.state)), this.decoratedTo = t.viewport.to;
  }
  update(t) {
    let e = b(t.state), r = G(t.state), i = r != G(t.startState), { viewport: s } = t.view, o = t.changes.mapPos(this.decoratedTo, 1);
    e.length < s.to && !i && e.type == this.tree.type && o >= s.to ? (this.decorations = this.decorations.map(t.changes), this.decoratedTo = o) : (e != this.tree || t.viewportChanged || i) && (this.tree = e, this.decorations = this.buildDeco(t.view, r), this.decoratedTo = s.to);
  }
  buildDeco(t, e) {
    if (!e || !this.tree.length)
      return m.none;
    let r = new gt();
    for (let { from: i, to: s } of t.visibleRanges)
      _t(this.tree, e, (o, a, l) => {
        r.add(o, a, this.markCache[l] || (this.markCache[l] = m.mark({ class: l })));
      }, i, s);
    return r.finish();
  }
}
const Ae = /* @__PURE__ */ zt.high(/* @__PURE__ */ _.fromClass(Ce, {
  decorations: (n) => n.decorations
})), on = /* @__PURE__ */ j.define([
  {
    tag: f.meta,
    color: "#404740"
  },
  {
    tag: f.link,
    textDecoration: "underline"
  },
  {
    tag: f.heading,
    textDecoration: "underline",
    fontWeight: "bold"
  },
  {
    tag: f.emphasis,
    fontStyle: "italic"
  },
  {
    tag: f.strong,
    fontWeight: "bold"
  },
  {
    tag: f.strikethrough,
    textDecoration: "line-through"
  },
  {
    tag: f.keyword,
    color: "#708"
  },
  {
    tag: [f.atom, f.bool, f.url, f.contentSeparator, f.labelName],
    color: "#219"
  },
  {
    tag: [f.literal, f.inserted],
    color: "#164"
  },
  {
    tag: [f.string, f.deleted],
    color: "#a11"
  },
  {
    tag: [f.regexp, f.escape, /* @__PURE__ */ f.special(f.string)],
    color: "#e40"
  },
  {
    tag: /* @__PURE__ */ f.definition(f.variableName),
    color: "#00f"
  },
  {
    tag: /* @__PURE__ */ f.local(f.variableName),
    color: "#30a"
  },
  {
    tag: [f.typeName, f.namespace],
    color: "#085"
  },
  {
    tag: f.className,
    color: "#167"
  },
  {
    tag: [/* @__PURE__ */ f.special(f.variableName), f.macroName],
    color: "#256"
  },
  {
    tag: /* @__PURE__ */ f.definition(f.propertyName),
    color: "#00c"
  },
  {
    tag: f.comment,
    color: "#940"
  },
  {
    tag: f.invalid,
    color: "#f00"
  }
]), Ie = /* @__PURE__ */ v.baseTheme({
  "&.cm-focused .cm-matchingBracket": { backgroundColor: "#328c8252" },
  "&.cm-focused .cm-nonmatchingBracket": { backgroundColor: "#bb555544" }
}), Mt = 1e4, Bt = "()[]{}", Et = /* @__PURE__ */ S.define({
  combine(n) {
    return pt(n, {
      afterCursor: !0,
      brackets: Bt,
      maxScanDistance: Mt,
      renderMatch: Ne
    });
  }
}), De = /* @__PURE__ */ m.mark({ class: "cm-matchingBracket" }), Oe = /* @__PURE__ */ m.mark({ class: "cm-nonmatchingBracket" });
function Ne(n) {
  let t = [], e = n.matched ? De : Oe;
  return t.push(e.range(n.start.from, n.start.to)), n.end && t.push(e.range(n.end.from, n.end.to)), t;
}
const Me = /* @__PURE__ */ Z.define({
  create() {
    return m.none;
  },
  update(n, t) {
    if (!t.docChanged && !t.selection)
      return n;
    let e = [], r = t.state.facet(Et);
    for (let i of t.state.selection.ranges) {
      if (!i.empty)
        continue;
      let s = B(t.state, i.head, -1, r) || i.head > 0 && B(t.state, i.head - 1, 1, r) || r.afterCursor && (B(t.state, i.head, 1, r) || i.head < t.state.doc.length && B(t.state, i.head + 1, -1, r));
      s && (e = e.concat(r.renderMatch(s, t.state)));
    }
    return m.set(e, !0);
  },
  provide: (n) => v.decorations.from(n)
}), Be = [
  Me,
  Ie
];
function ln(n = {}) {
  return [Et.of(n), Be];
}
const Ee = /* @__PURE__ */ new w();
function X(n, t, e) {
  let r = n.prop(t < 0 ? w.openedBy : w.closedBy);
  if (r)
    return r;
  if (n.name.length == 1) {
    let i = e.indexOf(n.name);
    if (i > -1 && i % 2 == (t < 0 ? 1 : 0))
      return [e[i + t]];
  }
  return null;
}
function Y(n) {
  let t = n.type.prop(Ee);
  return t ? t(n.node) : n;
}
function B(n, t, e, r = {}) {
  let i = r.maxScanDistance || Mt, s = r.brackets || Bt, o = b(n), a = o.resolveInner(t, e);
  for (let l = a; l; l = l.parent) {
    let h = X(l.type, e, s);
    if (h && l.from < l.to) {
      let u = Y(l);
      if (u && (e > 0 ? t >= u.from && t < u.to : t > u.from && t <= u.to))
        return Le(n, t, e, l, u, h, s);
    }
  }
  return Fe(n, t, e, o, a.type, i, s);
}
function Le(n, t, e, r, i, s, o) {
  let a = r.parent, l = { from: i.from, to: i.to }, h = 0, u = a == null ? void 0 : a.cursor();
  if (u && (e < 0 ? u.childBefore(r.from) : u.childAfter(r.to)))
    do
      if (e < 0 ? u.to <= r.from : u.from >= r.to) {
        if (h == 0 && s.indexOf(u.type.name) > -1 && u.from < u.to) {
          let c = Y(u);
          return { start: l, end: c ? { from: c.from, to: c.to } : void 0, matched: !0 };
        } else if (X(u.type, e, o))
          h++;
        else if (X(u.type, -e, o)) {
          if (h == 0) {
            let c = Y(u);
            return {
              start: l,
              end: c && c.from < c.to ? { from: c.from, to: c.to } : void 0,
              matched: !1
            };
          }
          h--;
        }
      }
    while (e < 0 ? u.prevSibling() : u.nextSibling());
  return { start: l, matched: !1 };
}
function Fe(n, t, e, r, i, s, o) {
  let a = e < 0 ? n.sliceDoc(t - 1, t) : n.sliceDoc(t, t + 1), l = o.indexOf(a);
  if (l < 0 || l % 2 == 0 != e > 0)
    return null;
  let h = { from: e < 0 ? t - 1 : t, to: e > 0 ? t + 1 : t }, u = n.doc.iterRange(t, e > 0 ? n.doc.length : 0), c = 0;
  for (let p = 0; !u.next().done && p <= s; ) {
    let d = u.value;
    e < 0 && (p += d.length);
    let y = t + p * e;
    for (let C = e > 0 ? 0 : d.length - 1, $t = e > 0 ? d.length : -1; C != $t; C += e) {
      let $ = o.indexOf(d[C]);
      if (!($ < 0 || r.resolveInner(y + C, 1).type != i))
        if ($ % 2 == 0 == e > 0)
          c++;
        else {
          if (c == 1)
            return { start: h, end: { from: y + C, to: y + C + 1 }, matched: $ >> 1 == l >> 1 };
          c--;
        }
    }
    e > 0 && (p += d.length);
  }
  return u.done ? { start: h, matched: !1 } : null;
}
function ht(n, t, e, r = 0, i = 0) {
  t == null && (t = n.search(/[^\s\u00a0]/), t == -1 && (t = n.length));
  let s = i;
  for (let o = r; o < t; o++)
    n.charCodeAt(o) == 9 ? s += e - s % e : s++;
  return s;
}
class Lt {
  /**
  Create a stream.
  */
  constructor(t, e, r, i) {
    this.string = t, this.tabSize = e, this.indentUnit = r, this.overrideIndent = i, this.pos = 0, this.start = 0, this.lastColumnPos = 0, this.lastColumnValue = 0;
  }
  /**
  True if we are at the end of the line.
  */
  eol() {
    return this.pos >= this.string.length;
  }
  /**
  True if we are at the start of the line.
  */
  sol() {
    return this.pos == 0;
  }
  /**
  Get the next code unit after the current position, or undefined
  if we're at the end of the line.
  */
  peek() {
    return this.string.charAt(this.pos) || void 0;
  }
  /**
  Read the next code unit and advance `this.pos`.
  */
  next() {
    if (this.pos < this.string.length)
      return this.string.charAt(this.pos++);
  }
  /**
  Match the next character against the given string, regular
  expression, or predicate. Consume and return it if it matches.
  */
  eat(t) {
    let e = this.string.charAt(this.pos), r;
    if (typeof t == "string" ? r = e == t : r = e && (t instanceof RegExp ? t.test(e) : t(e)), r)
      return ++this.pos, e;
  }
  /**
  Continue matching characters that match the given string,
  regular expression, or predicate function. Return true if any
  characters were consumed.
  */
  eatWhile(t) {
    let e = this.pos;
    for (; this.eat(t); )
      ;
    return this.pos > e;
  }
  /**
  Consume whitespace ahead of `this.pos`. Return true if any was
  found.
  */
  eatSpace() {
    let t = this.pos;
    for (; /[\s\u00a0]/.test(this.string.charAt(this.pos)); )
      ++this.pos;
    return this.pos > t;
  }
  /**
  Move to the end of the line.
  */
  skipToEnd() {
    this.pos = this.string.length;
  }
  /**
  Move to directly before the given character, if found on the
  current line.
  */
  skipTo(t) {
    let e = this.string.indexOf(t, this.pos);
    if (e > -1)
      return this.pos = e, !0;
  }
  /**
  Move back `n` characters.
  */
  backUp(t) {
    this.pos -= t;
  }
  /**
  Get the column position at `this.pos`.
  */
  column() {
    return this.lastColumnPos < this.start && (this.lastColumnValue = ht(this.string, this.start, this.tabSize, this.lastColumnPos, this.lastColumnValue), this.lastColumnPos = this.start), this.lastColumnValue;
  }
  /**
  Get the indentation column of the current line.
  */
  indentation() {
    var t;
    return (t = this.overrideIndent) !== null && t !== void 0 ? t : ht(this.string, null, this.tabSize);
  }
  /**
  Match the input against the given string or regular expression
  (which should start with a `^`). Return true or the regexp match
  if it matches.
  
  Unless `consume` is set to `false`, this will move `this.pos`
  past the matched text.
  
  When matching a string `caseInsensitive` can be set to true to
  make the match case-insensitive.
  */
  match(t, e, r) {
    if (typeof t == "string") {
      let i = (o) => r ? o.toLowerCase() : o, s = this.string.substr(this.pos, t.length);
      return i(s) == i(t) ? (e !== !1 && (this.pos += t.length), !0) : null;
    } else {
      let i = this.string.slice(this.pos).match(t);
      return i && i.index > 0 ? null : (i && e !== !1 && (this.pos += i[0].length), i);
    }
  }
  /**
  Get the current token.
  */
  current() {
    return this.string.slice(this.start, this.pos);
  }
}
function Re(n) {
  return {
    name: n.name || "",
    token: n.token,
    blankLine: n.blankLine || (() => {
    }),
    startState: n.startState || (() => !0),
    copyState: n.copyState || We,
    indent: n.indent || (() => null),
    languageData: n.languageData || {},
    tokenTable: n.tokenTable || rt
  };
}
function We(n) {
  if (typeof n != "object")
    return n;
  let t = {};
  for (let e in n) {
    let r = n[e];
    t[e] = r instanceof Array ? r.slice() : r;
  }
  return t;
}
const ut = /* @__PURE__ */ new WeakMap();
class Ft extends k {
  constructor(t) {
    let e = kt(t.languageData), r = Re(t), i, s = new class extends dt {
      createParse(o, a, l) {
        return new He(i, o, a, l);
      }
    }();
    super(e, s, [yt.of((o, a) => this.getIndent(o, a))], t.name), this.topNode = Ve(e), i = this, this.streamParser = r, this.stateAfter = new w({ perNode: !0 }), this.tokenTable = t.tokenTable ? new Ht(r.tokenTable) : $e;
  }
  /**
  Define a stream language.
  */
  static define(t) {
    return new Ft(t);
  }
  getIndent(t, e) {
    let r = b(t.state), i = r.resolve(e);
    for (; i && i.type != this.topNode; )
      i = i.parent;
    if (!i)
      return null;
    let s, { overrideIndentation: o } = t.options;
    o && (s = ut.get(t.state), s != null && s < e - 1e4 && (s = void 0));
    let a = nt(this, r, 0, i.from, s ?? e), l, h;
    if (a ? (h = a.state, l = a.pos + 1) : (h = this.streamParser.startState(t.unit), l = 0), e - l > 1e4)
      return null;
    for (; l < e; ) {
      let c = t.state.doc.lineAt(l), p = Math.min(e, c.to);
      if (c.length) {
        let d = o ? o(c.from) : -1, y = new Lt(c.text, t.state.tabSize, t.unit, d < 0 ? void 0 : d);
        for (; y.pos < p - c.from; )
          Wt(this.streamParser.token, y, h);
      } else
        this.streamParser.blankLine(h, t.unit);
      if (p == e)
        break;
      l = c.to + 1;
    }
    let u = t.lineAt(e);
    return o && s == null && ut.set(t.state, u.from), this.streamParser.indent(h, /^\s*(.*)/.exec(u.text)[1], t);
  }
  get allowsNesting() {
    return !1;
  }
}
function nt(n, t, e, r, i) {
  let s = e >= r && e + t.length <= i && t.prop(n.stateAfter);
  if (s)
    return { state: n.streamParser.copyState(s), pos: e + t.length };
  for (let o = t.children.length - 1; o >= 0; o--) {
    let a = t.children[o], l = e + t.positions[o], h = a instanceof g && l < i && nt(n, a, l, r, i);
    if (h)
      return h;
  }
  return null;
}
function Rt(n, t, e, r, i) {
  if (i && e <= 0 && r >= t.length)
    return t;
  !i && t.type == n.topNode && (i = !0);
  for (let s = t.children.length - 1; s >= 0; s--) {
    let o = t.positions[s], a = t.children[s], l;
    if (o < r && a instanceof g) {
      if (!(l = Rt(n, a, e - o, r - o, i)))
        break;
      return i ? new g(t.type, t.children.slice(0, s).concat(l), t.positions.slice(0, s + 1), o + l.length) : l;
    }
  }
  return null;
}
function Ue(n, t, e, r) {
  for (let i of t) {
    let s = i.from + (i.openStart ? 25 : 0), o = i.to - (i.openEnd ? 25 : 0), a = s <= e && o > e && nt(n, i.tree, 0 - i.offset, e, o), l;
    if (a && (l = Rt(n, i.tree, e + i.offset, a.pos + i.offset, !1)))
      return { state: a.state, tree: l };
  }
  return { state: n.streamParser.startState(r ? L(r) : 4), tree: g.empty };
}
class He {
  constructor(t, e, r, i) {
    this.lang = t, this.input = e, this.fragments = r, this.ranges = i, this.stoppedAt = null, this.chunks = [], this.chunkPos = [], this.chunk = [], this.chunkReused = void 0, this.rangeIndex = 0, this.to = i[i.length - 1].to;
    let s = A.get(), o = i[0].from, { state: a, tree: l } = Ue(t, r, o, s == null ? void 0 : s.state);
    this.state = a, this.parsedPos = this.chunkStart = o + l.length;
    for (let h = 0; h < l.children.length; h++)
      this.chunks.push(l.children[h]), this.chunkPos.push(l.positions[h]);
    s && this.parsedPos < s.viewport.from - 1e5 && (this.state = this.lang.streamParser.startState(L(s.state)), s.skipUntilInView(this.parsedPos, s.viewport.from), this.parsedPos = s.viewport.from), this.moveRangeIndex();
  }
  advance() {
    let t = A.get(), e = this.stoppedAt == null ? this.to : Math.min(this.to, this.stoppedAt), r = Math.min(
      e,
      this.chunkStart + 2048
      /* C.ChunkSize */
    );
    for (t && (r = Math.min(r, t.viewport.to)); this.parsedPos < r; )
      this.parseLine(t);
    return this.chunkStart < this.parsedPos && this.finishChunk(), this.parsedPos >= e ? this.finish() : t && this.parsedPos >= t.viewport.to ? (t.skipUntilInView(this.parsedPos, e), this.finish()) : null;
  }
  stopAt(t) {
    this.stoppedAt = t;
  }
  lineAfter(t) {
    let e = this.input.chunk(t);
    if (this.input.lineChunks)
      e == `
` && (e = "");
    else {
      let r = e.indexOf(`
`);
      r > -1 && (e = e.slice(0, r));
    }
    return t + e.length <= this.to ? e : e.slice(0, this.to - t);
  }
  nextLine() {
    let t = this.parsedPos, e = this.lineAfter(t), r = t + e.length;
    for (let i = this.rangeIndex; ; ) {
      let s = this.ranges[i].to;
      if (s >= r || (e = e.slice(0, s - (r - e.length)), i++, i == this.ranges.length))
        break;
      let o = this.ranges[i].from, a = this.lineAfter(o);
      e += a, r = o + a.length;
    }
    return { line: e, end: r };
  }
  skipGapsTo(t, e, r) {
    for (; ; ) {
      let i = this.ranges[this.rangeIndex].to, s = t + e;
      if (r > 0 ? i > s : i >= s)
        break;
      let o = this.ranges[++this.rangeIndex].from;
      e += o - i;
    }
    return e;
  }
  moveRangeIndex() {
    for (; this.ranges[this.rangeIndex].to < this.parsedPos; )
      this.rangeIndex++;
  }
  emitToken(t, e, r, i, s) {
    if (this.ranges.length > 1) {
      s = this.skipGapsTo(e, s, 1), e += s;
      let o = this.chunk.length;
      s = this.skipGapsTo(r, s, -1), r += s, i += this.chunk.length - o;
    }
    return this.chunk.push(t, e, r, i), s;
  }
  parseLine(t) {
    let { line: e, end: r } = this.nextLine(), i = 0, { streamParser: s } = this.lang, o = new Lt(e, t ? t.state.tabSize : 4, t ? L(t.state) : 2);
    if (o.eol())
      s.blankLine(this.state, o.indentUnit);
    else
      for (; !o.eol(); ) {
        let a = Wt(s.token, o, this.state);
        if (a && (i = this.emitToken(this.lang.tokenTable.resolve(a), this.parsedPos + o.start, this.parsedPos + o.pos, 4, i)), o.start > 1e4)
          break;
      }
    this.parsedPos = r, this.moveRangeIndex(), this.parsedPos < this.to && this.parsedPos++;
  }
  finishChunk() {
    let t = g.build({
      buffer: this.chunk,
      start: this.chunkStart,
      length: this.parsedPos - this.chunkStart,
      nodeSet: je,
      topID: 0,
      maxBufferLength: 2048,
      reused: this.chunkReused
    });
    t = new g(t.type, t.children, t.positions, t.length, [[this.lang.stateAfter, this.lang.streamParser.copyState(this.state)]]), this.chunks.push(t), this.chunkPos.push(this.chunkStart - this.ranges[0].from), this.chunk = [], this.chunkReused = void 0, this.chunkStart = this.parsedPos;
  }
  finish() {
    return new g(this.lang.topNode, this.chunks, this.chunkPos, this.parsedPos - this.ranges[0].from).balance();
  }
}
function Wt(n, t, e) {
  t.start = t.pos;
  for (let r = 0; r < 10; r++) {
    let i = n(t, e);
    if (t.pos > t.start)
      return i;
  }
  throw new Error("Stream parser failed to advance stream.");
}
const rt = /* @__PURE__ */ Object.create(null), N = [W.none], je = /* @__PURE__ */ new qt(N), ft = [], ct = /* @__PURE__ */ Object.create(null), Ut = /* @__PURE__ */ Object.create(null);
for (let [n, t] of [
  ["variable", "variableName"],
  ["variable-2", "variableName.special"],
  ["string-2", "string.special"],
  ["def", "variableName.definition"],
  ["tag", "tagName"],
  ["attribute", "attributeName"],
  ["type", "typeName"],
  ["builtin", "variableName.standard"],
  ["qualifier", "modifier"],
  ["error", "invalid"],
  ["header", "heading"],
  ["property", "propertyName"]
])
  Ut[n] = /* @__PURE__ */ jt(rt, t);
class Ht {
  constructor(t) {
    this.extra = t, this.table = Object.assign(/* @__PURE__ */ Object.create(null), Ut);
  }
  resolve(t) {
    return t ? this.table[t] || (this.table[t] = jt(this.extra, t)) : 0;
  }
}
const $e = /* @__PURE__ */ new Ht(rt);
function J(n, t) {
  ft.indexOf(n) > -1 || (ft.push(n), console.warn(t));
}
function jt(n, t) {
  let e = [];
  for (let a of t.split(" ")) {
    let l = [];
    for (let h of a.split(".")) {
      let u = n[h] || f[h];
      u ? typeof u == "function" ? l.length ? l = l.map(u) : J(h, `Modifier ${h} used at start of tag`) : l.length ? J(h, `Tag ${h} used as modifier`) : l = Array.isArray(u) ? u : [u] : J(h, `Unknown highlighting tag ${h}`);
    }
    for (let h of l)
      e.push(h);
  }
  if (!e.length)
    return 0;
  let r = t.replace(/ /g, "_"), i = r + " " + e.map((a) => a.id), s = ct[i];
  if (s)
    return s.id;
  let o = ct[i] = W.define({
    id: N.length,
    name: r,
    props: [Yt({ [r]: e })]
  });
  return N.push(o), o.id;
}
function Ve(n) {
  let t = W.define({ id: N.length, name: "Document", props: [P.add(() => n)], top: !0 });
  return N.push(t), t;
}
it.RTL, it.LTR;
export {
  ee as DocInput,
  j as HighlightStyle,
  St as IndentContext,
  K as LRLanguage,
  k as Language,
  wt as LanguageDescription,
  Xe as LanguageSupport,
  A as ParseContext,
  Ft as StreamLanguage,
  Lt as StringStream,
  tt as TreeIndentContext,
  ln as bracketMatching,
  Ee as bracketMatchingHandle,
  Dt as codeFolding,
  _e as continuedIndent,
  on as defaultHighlightStyle,
  kt as defineLanguageFacet,
  Ye as delimitedIndent,
  Ze as flatIndent,
  ye as foldAll,
  be as foldCode,
  H as foldEffect,
  rn as foldGutter,
  en as foldInside,
  nn as foldKeymap,
  pe as foldNodeProp,
  de as foldService,
  T as foldState,
  F as foldable,
  L as getIndentUnit,
  ie as getIndentation,
  se as indentNodeProp,
  tn as indentOnInput,
  yt as indentService,
  re as indentString,
  vt as indentUnit,
  x as language,
  P as languageDataProp,
  B as matchBrackets,
  te as sublanguageProp,
  sn as syntaxHighlighting,
  b as syntaxTree,
  ve as unfoldAll,
  we as unfoldCode,
  M as unfoldEffect
};
